#include <AltSoftSerial.h>
#include <SoftwareSerial.h>
#include <TFMPlus.h>
TFMPlus tfmP;
TFMPlus tfmP2;
// Green Relay
#define Ryan_Green_Relay 2
#define Cele_Green_Relay 3
// Orange Relay
#define Ryan_Orange_Relay 4
#define Cele_Orange_Relay 5
// Red Relay
#define Ryan_Red_Relay 10
#define Cele_Red_Relay 11
// TF Luna LiDAR Sensor 1
SoftwareSerial mySerial( 6, 7); //these are Backwards on purpose. blue=2(tx) yellow=3(rx)
// TF Luna LiDAR Sensor 2
AltSoftSerial altSerial; // uses pins 8/9
//-------------------------------------------
int distance;
int distance2;
// Timers used to track 2 states of time
unsigned long previousMillis;   // Sonar Calculations
unsigned long previousMillis2;  // Red - Orange - Green - Range Distance True/False
unsigned long previousMillis3;  // Historical Distance Data per Sonar Sensor
unsigned long previousMillis4;  // Motion True/False
unsigned long previousMillis5;  // Lighting function ->
// Time is measured in seconds (milliseconds)
long OneSecond = 1000L;
long HalfSecond = 500L;
long QuarterSecond = 250L;
long EighthSecond = 125L;
// Flags are used for relay logic
bool Range = false;
bool Motion = false;
//
bool Range2 = false;
bool Motion2 = false;
// Ryan's Sonar  Light Distance
bool RED = false;
bool ORANGE = false;
bool GREEN = false;
// Cele's Sonar  Light Distance
bool RED2 = false;
bool ORANGE2 = false;
bool GREEN2 = false;
// Used to keep record of time in DistanceHistory arrays
int i = 0;
int a = 0;
// Relay State Variables
int red_state;
int orange_state;
int green_state;
// Range variable in Centimeters for Ryan's Sonar 1
int MinimumDist = 30;
int RedLightDist = 100;
int OrangeLightDist = 206;
int GreenLightDist = 325;
// Range variable in Centimeters for Celeste's Sonar 2
int MinimumDist_CELE = 30;
int RedLightDist_CELE = 100;
int OrangeLightDist_CELE = 206;
int GreenLightDist_CELE = 325;
//	Array or Historical distance measurements = last 10 seconds.
int DistanceHistory[40] = {};
int DistanceHistory2[40] = {};

//==========================================================|
//           Single Run Boot up Sequence					|
//==========================================================|
void setup() {

  pinMode(Ryan_Red_Relay, OUTPUT);     // Red Lightbulb Relay
  pinMode(Ryan_Orange_Relay, OUTPUT);  // Orange Lightbulb Relay
  pinMode(Ryan_Green_Relay, OUTPUT);   // Green Lightbulb Relay
  pinMode(Cele_Red_Relay, OUTPUT);     // Red Lightbulb Relay
  pinMode(Cele_Orange_Relay, OUTPUT);  // Orange Lightbulb Relay
  pinMode(Cele_Green_Relay, OUTPUT);   // Green Lightbulb Relay
  Serial.begin(9600);
  while (!Serial) ; // wait for Arduino Serial Monitor to open
  altSerial.begin(115200);
  mySerial.begin(115200);
  //-----------------------------------------------------
  delay(20);
  tfmP.begin( &altSerial);
  tfmP.sendCommand( SET_FRAME_RATE, FRAME_20);
  delay(20);
  tfmP2.begin( &mySerial);
  tfmP2.sendCommand( SET_FRAME_RATE, FRAME_50);
  delay(500);
}
int16_t tfDist = 0;
int16_t tfDist2 = 0;
//==========================================================|
//           Main Program - START (Continuous Loop)			|
//==========================================================|
void loop() {
  delay(20);
tfmP.getData(tfDist);
tfmP2.getData(tfDist2);


  // TIMER --- Sonar Calculations
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis > QuarterSecond) {
    distance = tfDist;  
    distance2 = tfDist2;   
    Serial.print(distance);    Serial.print("  -  ");    Serial.println(distance2);
    previousMillis = currentMillis;
  }
  // TIMER ---  Red - Orange - Green - Range Distance True/False
  unsigned long currentMillis2 = millis();
  if (currentMillis2 - previousMillis2 >= QuarterSecond) {
    if (distance >= MinimumDist && distance <= RedLightDist) {
      RED = true;
      ORANGE = false;
      GREEN = false;
      Range = true;
    } else if (distance >= RedLightDist && distance <= OrangeLightDist) {
      RED = false;
      ORANGE = true;
      GREEN = false;
      Range = true;
    } else if (distance >= OrangeLightDist && distance <= GreenLightDist) {
      RED = false;
      ORANGE = false;
      GREEN = true;
      Range = true;
    } else {
      RED = false;
      ORANGE = false;
      GREEN = false;
      Range = false;
      i = 0; // This resets the Historical data in the Array for Ryan's Sonar Sensor 1
    }
    if (distance2 >= MinimumDist_CELE && distance2 <= RedLightDist_CELE) {
      RED2 = true;
      ORANGE2 = false;
      GREEN2 = false;
      Range2 = true;
    } else if (distance2 >= RedLightDist_CELE && distance2 <= OrangeLightDist_CELE) {
      RED2 = false;
      ORANGE2 = true;
      GREEN2 = false;
      Range2 = true;
    } else if (distance2 >= OrangeLightDist_CELE && distance2 <= GreenLightDist_CELE) {
      RED2 = false;
      ORANGE2 = false;
      GREEN2 = true;
      Range2 = true;
    } else {
      RED2 = false;
      ORANGE2 = false;
      GREEN2 = false;
      Range2 = false;
      a = 0; // This resets the Historical data in the Array for Celeste's Sonar Sensor 2
    }
    previousMillis2 = currentMillis2;
     //  Uncomment to enable live debugging of bool values TrueFalse(1/0) to fine tune logic
     //  Serial.print("Sonar 1: ");Serial.print(RED);Serial.print("-");Serial.print(ORANGE);Serial.print("-");Serial.print(GREEN);Serial.print("-");Serial.print(Range);Serial.print("-");Serial.print(Motion);  Serial.print("     -     Sonar 2: ");Serial.print(RED2);Serial.print("-");Serial.print(ORANGE2);Serial.print("-");Serial.print(GREEN2);Serial.print("-");Serial.print(Range2);Serial.print("-");Serial.println(Motion2);
  }
  // TIMER ---  Historical Distance Data per Sonar Sensor
  //        specifically do not use for loops here
  unsigned long currentMillis3 = millis();
  if (currentMillis3 - previousMillis3 >= QuarterSecond) {
    DistanceHistory[i] = distance;
    if (i < 39) {
      i = i + 1;
    } else if (i >= 39) {
      i = 0;
    }
    //	Serial.println("");Serial.print("array1= : ");Serial.print(DistanceHistory[0]);Serial.print(", ");Serial.print("array2= : ");Serial.print(DistanceHistory[1]);Serial.print(", ");Serial.print("array3= : ");Serial.print(DistanceHistory[2]);Serial.print(", ");Serial.print("array4= : ");Serial.print(DistanceHistory[3]);Serial.print(", ");Serial.print("array5= : ");Serial.println(DistanceHistory[4]);
    DistanceHistory2[a] = distance2;
    if (a < 39) {
      a = a + 1;
    } else if (a >= 39) {
      a = 0;
    }
    //	Serial.print("array1= : ");Serial.print(DistanceHistory2[0]);Serial.print(", ");Serial.print("array2= : ");Serial.print(DistanceHistory2[1]);Serial.print(", ");Serial.print("array3= : ");Serial.print(DistanceHistory2[2]);Serial.print(", ");Serial.print("array4= : ");Serial.print(DistanceHistory2[3]);Serial.print(", ");Serial.print("array5= : ");Serial.println(DistanceHistory2[4]);
    previousMillis3 = currentMillis3;
  }
  // TIMER ---  Motion True/False
  unsigned long currentMillis4 = millis();
  if (currentMillis4 - previousMillis4 >= QuarterSecond) {
    int maxVal = DistanceHistory[0];
    int minVal = DistanceHistory[0];
    for (int j = 0; j < (sizeof(DistanceHistory) / sizeof(DistanceHistory[0])); j++) {
      if (DistanceHistory[j] > maxVal) {
        maxVal = DistanceHistory[j];
      }
      if (DistanceHistory[j] < minVal) {
        minVal = DistanceHistory[j];
      }
    }
    //   Serial.print("Sonar1-Min-Dist: ");Serial.print(minVal);Serial.print("      -      Sonar1-Max-Dist: ");Serial.println(maxVal);
    int maxVal2 = DistanceHistory2[0];
    int minVal2 = DistanceHistory2[0];
    for (int b = 0; b < (sizeof(DistanceHistory2) / sizeof(DistanceHistory2[0])); b++) {
      if (DistanceHistory2[b] > maxVal2) {
        maxVal2 = DistanceHistory2[b];
      }
      if (DistanceHistory2[b] < minVal2) {
        minVal2 = DistanceHistory2[b];
      }
    }
    //   Serial.print("Sonar2-Min-Dist: ");Serial.print(minVal2);Serial.print("   -   Sonar2-Max-Dist: ");Serial.println(maxVal2);
// The following is used to determine if there is any Motion of objects that are within Range of the sonar sensors.
    if (Range == true) {
      if ((maxVal - minVal) <= 4) {
        Motion = false;
      } else {
        Motion = true;
      }
    } else {
      Motion = false;
    }
    if (Range2 == true) {
      if ((maxVal2 - minVal2) <= 8) {
        Motion2 = false;
      } else {
        Motion2 = true;
      }
    } else {
      Motion2 = false;
    }

    //	Serial.print("Sensor 1 Motion :  ");Serial.print(Motion);Serial.print(" -   Sensor 2 Motion :  ");Serial.println(Motion2);
    previousMillis4 = currentMillis4;
  }
  // TIMER ---  Lighting function ->
  unsigned long currentMillis5 = millis();
  if (currentMillis5 - previousMillis5 >= QuarterSecond) {
    StreetLights();
    //Serial.print("Ryan: ");Serial.print(distance);Serial.print("  -  Cele: ");Serial.print(distance2);Serial.print("   --- ");Serial.println(currentMillis5);
    previousMillis5 = currentMillis5;
  }
}


//
//=======================================================================
//

void StreetLights() {
  if (Motion == false) {
    Lights_OFF_RYAN();
    if (Motion2 == true) {
      CELE_RED_ON();
      CELE_ORANGE_ON();
      CELE_GREEN_ON();
    }
  }
  //-------------------
  if (Motion == true) {
    RYAN_RED_ON();
    RYAN_ORANGE_ON();
    RYAN_GREEN_ON();
  }
  //-------------------
  if (Motion2 == false) {
    Lights_OFF_CELE();
    if (Motion == true) {
      RYAN_RED_ON();
      RYAN_ORANGE_ON();
      RYAN_GREEN_ON();
    }
  }
  //-------------------
  if (Motion2 == true) {
    CELE_RED_ON();
    CELE_ORANGE_ON();
    CELE_GREEN_ON();
    //-------------------
  } else if (Range == false && Range2 == false) {
    Lights_OFF();
  }
}

void Lights_OFF() {
  digitalWrite(Ryan_Red_Relay, LOW);
  digitalWrite(Ryan_Orange_Relay, LOW);
  digitalWrite(Ryan_Green_Relay, LOW);
  digitalWrite(Cele_Red_Relay, LOW);
  digitalWrite(Cele_Orange_Relay, LOW);
  digitalWrite(Cele_Green_Relay, LOW);
}
void Lights_OFF_RYAN() {
  digitalWrite(Ryan_Red_Relay, LOW);
  digitalWrite(Ryan_Orange_Relay, LOW);
  digitalWrite(Ryan_Green_Relay, LOW);
}
void Lights_OFF_CELE() {
  digitalWrite(Cele_Red_Relay, LOW);
  digitalWrite(Cele_Orange_Relay, LOW);
  digitalWrite(Cele_Green_Relay, LOW);
}

//----------------------------------
void RYAN_RED_ON() {
  if (RED == true) {
    digitalWrite(Ryan_Red_Relay, HIGH);
    RYAN_ORANGE_OFF();
    RYAN_GREEN_OFF();
  }
}
//----------------------------------
void RYAN_ORANGE_ON() {
  if (ORANGE == true) {
    digitalWrite(Ryan_Orange_Relay, HIGH);
    RYAN_RED_OFF();
    RYAN_GREEN_OFF();
  }
}
//----------------------------------
void RYAN_GREEN_ON() {
  if (GREEN == true) {
    digitalWrite(Ryan_Green_Relay, HIGH);
    RYAN_ORANGE_OFF();
    RYAN_RED_OFF();
  }
}
//----------------------------------
void CELE_RED_ON() {
  if (RED2 == true) {
    digitalWrite(Cele_Red_Relay, HIGH);
    CELE_ORANGE_OFF();
    CELE_GREEN_OFF();
  }
}
//----------------------------------
void CELE_ORANGE_ON() {
  if (ORANGE2 == true) {
    digitalWrite(Cele_Orange_Relay, HIGH);
    CELE_GREEN_OFF();
    CELE_RED_OFF();
  }
}

//----------------------------------
void CELE_GREEN_ON() {
  if (GREEN2 == true) {
    digitalWrite(Cele_Green_Relay, HIGH);
    CELE_ORANGE_OFF();
    CELE_RED_OFF();
  }
}

//----------------------------------
void RYAN_RED_OFF() {
  digitalWrite(Ryan_Red_Relay, LOW);
}
//----------------------------------
void RYAN_ORANGE_OFF() {
  digitalWrite(Ryan_Orange_Relay, LOW);
}
//----------------------------------
void RYAN_GREEN_OFF() {
  digitalWrite(Ryan_Green_Relay, LOW);
}

//----------------------------------
void CELE_RED_OFF() {
  digitalWrite(Cele_Red_Relay, LOW);
}
//----------------------------------
void CELE_ORANGE_OFF() {
  digitalWrite(Cele_Orange_Relay, LOW);
}
//----------------------------------
void CELE_GREEN_OFF() {
  digitalWrite(Cele_Green_Relay, LOW);
}